%define module hid-tmff2

%global commit0 a9312ead5720922e1c06b541ea48b6db3f289d36
%global shortcommit0 %(c=%{commit0}; echo ${c:0:7})
%global date 20250203

%global commit1 17d6cad0b508417193ebf4d23f67c845487e9932
%global shortcommit1 %(c=%{commit1}; echo ${c:0:7})

%define rel 1

Name:       hid-tmff2
#From dkms.conf
Version:    0.82
Release:    %mkrel %{rel}.%{date}git%{shortcommit0}
Summary:    Improved module driver for Logitech driving wheels
Group:		System/Kernel and hardware
License:    GPLv3
URL:        https://github.com/Kimplul/hid-tmff2
Source0:	%{url}/archive/%{commit0}/%{name}-%{shortcommit0}.tar.gz
Source1:     https://github.com/Kimplul/hid-tminit/archive/%{commit1}/hid-tminit-%{shortcommit1}.tar.gz
# From aur https://aur.archlinux.org/cgit/aur.git/plain/hid-tmff2-dkms-git.conf?h=hid-tmff2-dkms-git
Source2:	blacklist-thrustmaster.conf

Requires: dkms
Requires: kernel-devel
Requires: oversteer

BuildArch:	noarch

%description
Linux kernel module for Thrustmaster T300RS, T248 and (experimental) TX,
T128 and TS-XW wheelss

A Linux kernel module for Thrustmaster T300RS, T248, and (experimental
support) TX and TS-XV wheels,  this use the HID++ protocol and are supported
by the HID++ driver as of kernel 6.3.

%prep
%autosetup -n %{name}-%{commit0} -a1 -p1

rm -rf deps/hid-tminit
mv hid-tminit-%{commit1} deps/hid-tminit

sed -e "s/%{version}/%{version}\-%{release}/" -i dkms/dkms.conf

%install
mkdir -p %{buildroot}/{/usr/src/%{module}-%{version}-%{release},%{_prefix}/lib/udev/rules.d,%{_docdir}}

cp -r . %{buildroot}/usr/src/%{module}-%{version}-%{release}
mv %{buildroot}/usr/src/%{module}-%{version}-%{release}/dkms/dkms.conf %{buildroot}/usr/src/%{module}-%{version}-%{release}

mv %{buildroot}/usr/src/%{module}-%{version}-%{release}/udev/* %{buildroot}/%{_prefix}/lib/udev/rules.d/

mv %{buildroot}/usr/src/%{module}-%{version}-%{release}/docs %{buildroot}/%{_docdir}/%{name}

install -Dm644 %{SOURCE2} %{buildroot}/usr/lib/modprobe.d/blacklist-thrustmaster.conf

#Cleaning
rm -rf %{buildroot}/usr/src/%{module}-%{version}-%{release}/{dkms,udev} 
rm -f %{buildroot}/usr/src/%{module}-%{version}-%{release}/{README.md,LICENSE}

%files
%doc README.md 
%license LICENSE
%defattr(0644,root,root)
%attr(0755,root,root) /usr/src/%{module}-%{version}-%{release}/
%{_prefix}/lib/udev/rules.d/*.rules
%{_docdir}/%{name}/*
/usr/lib/modprobe.d/blacklist-thrustmaster.conf

%post
dkms add	-m %{module} -v %{version}-%{release} --rpm_safe_upgrade &&
dkms build	-m %{module} -v %{version}-%{release} --rpm_safe_upgrade &&
dkms install	-m %{module} -v %{version}-%{release} --rpm_safe_upgrade
true
# Unloading hid_thrustmaster to avoid conflict
# See the .conf file containing the blacklist for info why
# But despite blacklisting it we unload it immedialty for make sure it is gone
lsmod|grep hid_thrustmaster && rmmod hid_thrustmaster || true

%preun
dkms remove  -m %{module} -v %{version}-%{release} --all --rpm_safe_upgrade
true


%changelog
* Tue Mar 18 2025 katnatek <katnatek> 0.82-1.20250203gita9312ea.mga10
+ Revision: 2166249
- Fix summary
- Fix description
- Remove duplicated files
- Put all the cleaning together
- Add -p1 to %%autosetup
- Not use hardcoded version in sed for dkms.conf
- remove obsolete %%clean section
- imported package hid-tmff2

